<template>
  <div class="fr-grid-row fr-grid-row--gutters">
    <div
      v-if="!hasDocuments"
      class="fr-col-12"
    >
      <p>
        Ajoutez un document pour commencer à alimenter l'espace document du
        bénéficiaire.
      </p>
    </div>

    <div
      v-for="[type, typeLabel] in availableDocumentTypes"
      :key="type"
      class="fr-col-12 fr-col-lg-6"
    >
      <div class="fr-h6">{{ typeLabel }}</div>
      <ul class="document-list">
        <li
          v-for="document in documents[type]"
          :key="document.id"
        >
          <BeneficiaryDocument
            :document="document"
            :unread-notifications="unreadNotifications"
            @deleted="$emit('documentDeleted', $event)"
            @edited="$emit('documentEdited', $event)"
          />
        </li>
      </ul>
    </div>
  </div>
</template>

<script setup>
  import { DOCUMENT_TYPE_OPTIONS } from '~/utils/constants/document'

  const props = defineProps({
    documents: {
      validator(documents) {
        return (
          typeof documents === 'object' &&
          [...DOCUMENT_TYPE_OPTIONS.keys()].reduce(
            (valid, type) => valid && Array.isArray(documents[type]),
            true
          )
        )
      },
      required: true
    },
    unreadNotifications: { type: Array, required: true }
  })

  defineEmits(['documentEdited', 'documentDeleted'])

  const availableDocumentTypes = computed(() =>
    [...DOCUMENT_TYPE_OPTIONS.entries()].filter(
      ([type]) => props.documents[type].length
    )
  )

  const hasDocuments = computed(() => availableDocumentTypes.value.length)
</script>

<style lang="scss" scoped>
  @use '@gouvfr/dsfr/src/core/index' as dsfr;

  .document-list {
    @include dsfr.disable-list-style;

    --li-bottom: 1rem;
  }

  .document-list > li {
    padding-bottom: var(--li-bottom);
  }
</style>
